#
# Copyright (c) 2004-2011 Purdue University All rights reserved.
# 
# Developed by: HUBzero Technology Group, Purdue University
#               http://hubzero.org
# 
# HUBzero is free software: you can redistribute it and/or modify it under the terms of the
# GNU Lesser General Public License as published by the Free Software Foundation, either
# version 3 of the License, or (at your option) any later version.
# 
# HUBzero is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
# without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
# See the GNU Lesser General Public License for more details.  You should have received a
# copy of the GNU Lesser General Public License along with HUBzero.
# If not, see <http://www.gnu.org/licenses/>.
# 
# GNU LESSER GENERAL PUBLIC LICENSE
# Version 3, 29 June 2007
# Copyright (C) 2007 Free Software Foundation, Inc. <http://fsf.org/>
#
import os.path
import re

class EnvironmentWhitelistInfo:
   def __init__(self,
                infoDirectory,
                whiteListFile):
      self.environmentWhiteList = []

      commentPattern  = re.compile('\s*#.*')

      fpWhiteList = open(os.path.join(infoDirectory,whiteListFile), 'r')
      if fpWhiteList:
         eof = False
         while not eof:
            record = fpWhiteList.readline()
            if record != "":
               record = commentPattern.sub("",record).strip()
               if record != "":
                  self.environmentWhiteList.append(record)
            else:
               eof = True
         fpWhiteList.close()


   def isVariableInWhiteList(self,
                             variable):
      return(variable in self.environmentWhiteList)


